#!/usr/bin/perl -wT
#
# Author name:Aljerin L. Butler, Jr.
# Creation date:May 7, 2011
#
# Description:
# match_colors.pl takes each color code combination from
# browser_safe.txt file and looks for a match, 1st in color_blind-rgb.txt
# If it doesnt't find a match there, it looks in rgb-x.txt.
# Whenever it finds a match it writes the entire string to match_found.txt

my ($bs_code, @rgb_array, $rgb, $cb_code, $xorg, $match_cb);	# declare variables
my $indir="/media/Cruzer/custom_desktop_solutions/documents/website";	# where to find input files

# open input file and read rgb codes to find a match
open(RGB, "<browser_safe.txt") or die "can't open browser_safe.txt:$!\n";

while($bs_code=<RGB>)	{	# read in line of browser safe rgb codes		
	chomp $bs_code;
	@rgb_array=split(/ /, $bs_code);	# create array from line of rgb codes	
	foreach $rgb (@rgb_array)	{	# start match						
		$match_cb="no";	# initialize match flag	
		open(BLIND, "<$indir/color_blind-rgb.txt") or die "can't open color_blind-rgb.txt:$!\n";
		while($cb_code=<BLIND>)	{	# begin scan - color_blind-rgb.txt			
			chomp $cb_code;			
			if ($cb_code=~m/$rgb/)	{	# is there a match?			
				print "you have a match: $cb_code\n";
				open(MATCH, ">>match_found.txt") or die "can't open match_found.txt:$!\n";
				print MATCH "$cb_code\n";	# write entry to match_found.txt
				close MATCH or die "can't close match_found.txt:$!\n";
				$match_cb="yes";	# set match flag
				# skip rest of color_blind-rgb.txt and grab next $rgb code
				last;
			}			
		}	# end of scan - color_blind.txt/no match found
		# reset pointer to color_blind-rgb.txt to beginning of file
		close BLIND or die "can't close color_blind.txt:$!\n";
		if ($match_cb eq "yes")	{	# if there was a match, skip rgb-x.txt scan
			next;			# and grab next $rgb code
		}
		open(XORG, "<$indir/rgb-x.txt") or die "can't open rgb-x.txt:$!\n";
		while($xorg=<XORG>)	{	# begin scan - rgb-x.txt
			chomp $xorg;						
			if ($xorg=~m/$rgb/)	{	# is there a match?
				print "you have a match: $xorg\n";
				open(MATCH, ">>match_found.txt") or die "can't open match_found.txt:$!\n";
				print MATCH "$xorg\n";	# write entry to match_found.txt
				close MATCH or die "can't close match_found.txt:$!\n";
				# skip rest of rgb-x.txt and grab next $rgb code
				last;
			}							
		}	# end of scan - rgb-x.txt/no match found
		# reset pointer to rgb-x.txt to beginning of file
		close XORG or die "can't close rgb-x.txt:$!\n";
	}	# end of array - @rgb_array
}	# end of read - browser_safe.txt
close RGB or die "can't close browser_safe.txt:$!\n";
print "End of program - open match_found.txt to see matches for browser-safe colors\n";














